Index: src/edu/ucsb/nceas/metacat/DBQuery.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DBQuery.java	(revision 1216)
+++ src/edu/ucsb/nceas/metacat/DBQuery.java	(revision 1217)
@@ -59,7 +59,7 @@
   static final int WRITE = 2;
   static final int READ = 4;
  
-  private Connection  conn = null;
+  //private Connection  conn = null;
   private String  parserName = null;
   private MetaCatUtil util = new MetaCatUtil();
   /**
@@ -97,12 +97,12 @@
 
           // Open a connection to the database
           MetaCatUtil   util = new MetaCatUtil();
-          Connection dbconn = util.openDBConnection();
+          //Connection dbconn = util.openDBConnection();
 
           double connTime = System.currentTimeMillis();
 
           // Execute the query
-          DBQuery queryobj = new DBQuery(dbconn, util.getOption("saxparser"));
+          DBQuery queryobj = new DBQuery(util.getOption("saxparser"));
           FileReader xml = new FileReader(new File(xmlfile));
           Hashtable nodelist = null;
           nodelist = queryobj.findDocuments(xml, null, null, useXMLIndex);
@@ -170,11 +170,11 @@
    * @param parserName the fully qualified name of a Java class implementing
    *                   the org.xml.sax.XMLReader interface
    */
-  public DBQuery( Connection conn, String parserName ) 
+  public DBQuery(String parserName ) 
                   throws IOException, 
                          SQLException, 
                          ClassNotFoundException {
-    this.conn = conn;
+    //this.conn = conn;
     this.parserName = parserName;
   }
   
@@ -211,17 +211,22 @@
       String fieldname = null;
       String fielddata = null;
       String relation = null;
-      Connection dbconn = null;
-      Connection dbconn2 = null;
+      //Connection dbconn = null;
+      //Connection dbconn2 = null;
       int rev = 0;
-      StringBuffer document = null; 
+      StringBuffer document = null;
+      DBConnection dbconn = null;
+      int serialNumber = -1;
       
       try {
-        if (conn == null || conn.isClosed()) {
+        /*if (conn == null || conn.isClosed()) {
           dbconn = util.openDBConnection();
         } else {
           dbconn = conn;
-        }
+        }*/
+        
+        dbconn=DBConnectionPool.getDBConnection("DBQuery.findDocuments");
+        serialNumber=dbconn.getCheckOutSerialNumber();
         // problem with ODBC driver multi-threading
      //   dbconn2 = util.openDBConnection(); // for use by AccessControlList
         
@@ -239,7 +244,7 @@
         while (tableHasRows) 
         {
           docid = rs.getString(1).trim();
-          if ( !hasPermission(dbconn, user, groups, docid) ) {
+          if ( !hasPermission(user, groups, docid) ) {
             // Advance to the next record in the cursor
             tableHasRows = rs.next();
             continue;
@@ -279,6 +284,8 @@
             
             PreparedStatement npstmt = dbconn.
                                        prepareStatement(btBuf.toString());
+            //should incease usage count
+            dbconn.increaseUsageCount(1);
             npstmt.execute();
             ResultSet btrs = npstmt.getResultSet();
             boolean hasBtRows = btrs.next();
@@ -293,7 +300,7 @@
                 // xmldoc = new DocumentImpl(dbconn, packageDocid);
                 //  thus use the following to get the doc info only
                 //  xmldoc = new DocumentImpl(dbconn);
-                xmldoc = new DocumentImpl(dbconn, packageDocid, false);
+                xmldoc = new DocumentImpl(packageDocid, false);
                 if (xmldoc == null) {
                   util.debugMessage("Document was null for: "+packageDocid, 50);
                 }
@@ -388,6 +395,8 @@
             //pstmt.close();
             pstmt = dbconn.prepareStatement(qspec.printExtendedSQL(
                                         doclist.toString()));
+            //increase dbconnection usage count
+            dbconn.increaseUsageCount(1);
             pstmt.execute();
             rs = pstmt.getResultSet();
             tableHasRows = rs.next();
@@ -394,7 +403,7 @@
             while(tableHasRows) 
             {
               docid = rs.getString(1).trim();
-              if ( !hasPermission(dbconn, user, groups, docid) ) {
+              if ( !hasPermission(user, groups, docid) ) {
                 // Advance to the next record in the cursor
                 tableHasRows = rs.next();
                 continue;
@@ -485,17 +494,22 @@
                            ee.getMessage());
         ee.printStackTrace(System.err);
       }
-      finally {
+      finally 
+      {
         try
         {
-          dbconn.close();
-        //  dbconn2.close();
-        }
-        catch(SQLException sqle)
+          pstmt.close();
+        }//try
+        catch (SQLException sqlE)
         {
-          System.out.println("error closing conn in DBQuery.findDocuments");
-        }
-      }
+          MetaCatUtil.debugMessage("Error in DBQuery.findDocuments: "
+                                      +sqlE.getMessage(), 30);
+        }//catch
+        finally
+        {
+          DBConnectionPool.returnDBConnection(dbconn, serialNumber);
+        }//finally
+      }//finally
     //System.out.println("docListResult: ");
     //System.out.println(docListResult.toString());
     return docListResult;
@@ -507,11 +521,11 @@
    * in the order in which they appearred in the document.
    * @param nodename the name or path of the particular node.
    * @param docid the docid of the document you want the node from.
-   * @param conn a database connection-this allows this method to be static
    */
-  public static Object[] getNodeContent(String nodename, String docid, 
-                                        Connection conn)
+  public static Object[] getNodeContent(String nodename, String docid)
   {
+    DBConnection dbconn = null;
+    int serialNumber = -1;
     StringBuffer query = new StringBuffer();
     Vector result = new Vector();
     PreparedStatement pstmt = null;
@@ -521,7 +535,9 @@
     query.append("' and docid like '").append(docid).append("')");
     try
     {
-      pstmt = conn.prepareStatement(query.toString());
+      dbconn=DBConnectionPool.getDBConnection("DBQuery.getNodeContent");
+        serialNumber=dbconn.getCheckOutSerialNumber();
+      pstmt = dbconn.prepareStatement(query.toString());
 
       // Execute the SQL query using the JDBC connection
       pstmt.execute();
@@ -542,7 +558,13 @@
       {
         pstmt.close();
       }
-      catch(SQLException sqle) {}
+      catch(SQLException sqle) 
+      {}
+      finally
+      {
+        DBConnectionPool.returnDBConnection(dbconn, serialNumber);
+      }
+      
     }
     return result.toArray();
   }
@@ -779,13 +801,14 @@
     * Check for "READ" permission on @docid for @user and/or @group 
     * from DB connection 
     */
-  private boolean hasPermission ( Connection conn, String user,
+  private boolean hasPermission (String user,
                                   String[] groups, String docid ) 
                   throws SQLException, Exception
   {
     // Check for READ permission on @docid for @user and/or @groups
-    AccessControlList aclobj = new AccessControlList(conn);
-    return aclobj.hasPermission("READ", user, groups, docid);
+    //AccessControlList aclobj = new AccessControlList();
+    //return aclobj.hasPermission("READ", user, groups, docid);
+    return AccessControlList.hasPermission("READ", user, groups, docid);
   }
 
   /**
@@ -794,8 +817,10 @@
     */
   private Vector getCurrentDocidListForDataPackage(String dataPackageDocid)
   {
+    DBConnection dbConn = null;
+    int serialNumber = -1;
     Vector docIdList=new Vector();//return value
-    PreparedStatement pStmt;
+    PreparedStatement pStmt = null;
     ResultSet rs=null;
     String docIdInSubjectField=null;
     String docIdInObjectField=null;
@@ -803,7 +828,10 @@
     String query="SELECT subject, object from xml_relation where docId = ?";
     try
     {
-      pStmt=conn.prepareStatement(query);
+      dbConn=DBConnectionPool.
+                  getDBConnection("DBQuery.getCurrentDocidListForDataPackage");
+      serialNumber=dbConn.getCheckOutSerialNumber();
+      pStmt=dbConn.prepareStatement(query);
       //bind the value to query
       pStmt.setString(1, dataPackageDocid);
 
@@ -840,6 +868,22 @@
       util.debugMessage("Error in getDocidListForDataPackage: "
                             +e.getMessage(), 30);
     }//catch
+    finally
+    {
+      try
+      {
+        pStmt.close();
+      }//try
+      catch (SQLException ee)
+      {
+        util.debugMessage("Error in getDocidListForDataPackage: "
+                            +ee.getMessage(), 30);
+      }//catch     
+      finally
+      {
+        DBConnectionPool.returnDBConnection(dbConn, serialNumber);
+      }//fianlly
+    }//finally
     return docIdList;
   }//getCurrentDocidListForDataPackadge()
   
@@ -854,42 +898,36 @@
     Vector docIdList=new Vector();//return value
     Vector tripleList=null;
     String xml=null;
-    Connection dbConn=null;
+   
+      //initial a documentImpl object 
+      DocumentImpl packageDocument = 
+                  new DocumentImpl(dataPackageDocid);
+      //transfer to documentImpl object to string
+      xml=packageDocument.toString();
     
-    if (conn == null || conn.isClosed())
-    {
-      dbConn = util.openDBConnection();
-    }
-    else
-    {
-      dbConn=conn;
-    }
-    //initial a documentImpl object 
-    DocumentImpl packageDocument = new DocumentImpl(dbConn, dataPackageDocid);
-    //transfer to documentImpl object to string
-    xml=packageDocument.toString();
-    
-    //create a tripcollection object
-    TripleCollection tripleForPackage = new 
+      //create a tripcollection object
+      TripleCollection tripleForPackage = new 
                                      TripleCollection(new StringReader(xml));
-    //get the vetor of triples 
-    tripleList=tripleForPackage.getCollection();
+      //get the vetor of triples 
+      tripleList=tripleForPackage.getCollection();
     
-    for (int i= 0; i<tripleList.size(); i++)
-    {
-      //put subject docid  into docIdlist without duplicate
-      if (!docIdList.contains(((Triple)tripleList.elementAt(i)).getSubject()))
+      for (int i= 0; i<tripleList.size(); i++)
       {
-        //put subject docid  into docIdlist
-         docIdList.add(((Triple)tripleList.get(i)).getSubject());
-      }
-      //put object docid into docIdlist without duplicate
-      if (!docIdList.contains(((Triple)tripleList.elementAt(i)).getObject()))
-      {
-         docIdList.add(((Triple)(tripleList.get(i))).getObject());
-      }
-    }//for
+        //put subject docid  into docIdlist without duplicate
+        if (!docIdList.contains(((Triple)tripleList.elementAt(i)).getSubject()))
+        {
+          //put subject docid  into docIdlist
+          docIdList.add(((Triple)tripleList.get(i)).getSubject());
+        }
+        //put object docid into docIdlist without duplicate
+        if (!docIdList.contains(((Triple)tripleList.elementAt(i)).getObject()))
+        {
+          docIdList.add(((Triple)(tripleList.get(i))).getObject());
+        }
+      }//for
+  
     
+    
     return docIdList;
   }//getDocidListForPackageInXMLRevisions()  
   
@@ -904,12 +942,17 @@
   private boolean isDataPackageId(String docId)
   {
     boolean result=false;
-    PreparedStatement pStmt;
+    PreparedStatement pStmt = null;
     ResultSet rs=null;
     String query="SELECT docId from xml_relation where docId = ?";
+    DBConnection dbConn = null;
+    int serialNumber = -1;
     try
     {
-      pStmt=conn.prepareStatement(query);
+      dbConn=DBConnectionPool.
+                  getDBConnection("DBQuery.isDataPackageId");
+      serialNumber=dbConn.getCheckOutSerialNumber();
+      pStmt=dbConn.prepareStatement(query);
       //bind the value to query
       pStmt.setString(1, docId);
       //execute the query
@@ -924,9 +967,25 @@
     }//try
     catch (SQLException e)
     {
-      util.debugMessage("Error in getDocidListForDataPackadge: "
+      util.debugMessage("Error in isDataPackageId: "
                             +e.getMessage(), 30);
     }
+    finally
+    {
+      try
+      {
+        pStmt.close();
+      }//try
+      catch (SQLException ee)
+      {
+        MetaCatUtil.debugMessage("Error in isDataPackageId: "
+                                                        + ee.getMessage(), 30);
+      }//catch
+      finally
+      {
+        DBConnectionPool.returnDBConnection(dbConn, serialNumber);
+      }//finally
+    }//finally
     return result;
   }//isDataPackageId()
   
@@ -937,12 +996,12 @@
    * @param user, the name of user
    * @param groups, the user's group
    */ 
-   private boolean hasPermissionToExportPackage(Connection conn, String docId, 
+   private boolean hasPermissionToExportPackage(String docId, 
                                         String user, String[] groups)
                    throws Exception
    {
-     DocumentImpl doc=new DocumentImpl(conn,docId);
-     return doc.hasReadPermission(conn, user, groups,docId);
+     //DocumentImpl doc=new DocumentImpl(conn,docId);
+     return DocumentImpl.hasReadPermission(user, groups,docId);
    }
    
   /**
@@ -953,12 +1012,17 @@
   private int getCurrentRevFromXMLDoumentsTable(String docId)
   {
     int rev=-5;
-    PreparedStatement pStmt;
+    PreparedStatement pStmt = null;
     ResultSet rs=null;
     String query="SELECT rev from xml_documents where docId = ?";
+    DBConnection dbConn=null;
+    int serialNumber = -1;
     try
     {
-      pStmt=conn.prepareStatement(query);
+      dbConn=DBConnectionPool.
+                  getDBConnection("DBQuery.getCurrentRevFromXMLDocumentsTable");
+      serialNumber=dbConn.getCheckOutSerialNumber();
+      pStmt=dbConn.prepareStatement(query);
       //bind the value to query
       pStmt.setString(1, docId);
       //execute the query
@@ -977,9 +1041,25 @@
     }//try
     catch (SQLException e)
     {
-      util.debugMessage("Error in getDocidListForDataPackadge: "
+      util.debugMessage("Error in getCurrentRevFromXMLDoumentsTable: "
                             +e.getMessage(), 30);
-    }
+    }//catch
+    finally
+    {
+      try
+      {
+        pStmt.close();
+      }//try
+      catch (SQLException ee)
+      {
+        MetaCatUtil.debugMessage("Error in getCurrentRevFromXMLDoumentsTable: "
+                                  +ee.getMessage(), 30);
+      }//catch
+      finally
+      {
+        DBConnectionPool.returnDBConnection(dbConn, serialNumber);
+      }//finally
+    }//finally
     return rev;
   }//getCurrentRevFromXMLDoumentsTable
  
@@ -1018,11 +1098,11 @@
   private Vector getCurrentAllDocumentImpl( Vector docIdList)
                               throws McdbException,Exception
   {
-    Connection dbConn=null;
+    //Connection dbConn=null;
     Vector documentImplList=new Vector();
     int rev=0; 
     
-    if (conn == null || conn.isClosed())
+    /*if (conn == null || conn.isClosed())
     {
       dbConn = util.openDBConnection();
     }
@@ -1029,7 +1109,7 @@
     else
     {
       dbConn=conn;
-    }
+    }*/
     //for every docid in vector
     for (int i=0;i<docIdList.size();i++)
     {
@@ -1040,7 +1120,7 @@
                         +util.getOption("accNumSeparator")+rev;
       //create new documentImpl object
       DocumentImpl documentImplObject = 
-                                    new DocumentImpl(dbConn,docidPlusVersion);
+                                    new DocumentImpl(docidPlusVersion);
       //add them to vector                            
       documentImplList.add(documentImplObject);
       
@@ -1057,13 +1137,13 @@
   private Vector getOldVersionAllDocumentImpl( Vector docIdList)
                               throws McdbException,Exception
   {
-    Connection dbConn=null;
+    //Connection dbConn=null;
     Vector documentImplList=new Vector();
     String siteCode=null;
     String uniqueId=null;
     int rev=0; 
     
-    if (conn == null || conn.isClosed())
+    /*if (conn == null || conn.isClosed())
     {
       dbConn = util.openDBConnection();
     }
@@ -1070,7 +1150,7 @@
     else
     {
       dbConn=conn;
-    }
+    }*/
     //for every docid in vector
     for (int i=0;i<docIdList.size();i++)
     {
@@ -1078,7 +1158,7 @@
         String docidPlusVersion=(String)(docIdList.elementAt(i));
         //create new documentImpl object
         DocumentImpl documentImplObject = 
-                                    new DocumentImpl(dbConn,docidPlusVersion);
+                                    new DocumentImpl(docidPlusVersion);
         //add them to vector                            
         documentImplList.add(documentImplObject);
       
@@ -1141,10 +1221,10 @@
     byte[] byteString=null;
     InputStream source;
     DBTransform xmlToHtml;
-    Connection dbConn;
+    //Connection dbConn;
 
     //get the connection to the database
-    if (conn == null || conn.isClosed())
+    /*if (conn == null || conn.isClosed())
     {
       dbConn = util.openDBConnection();
     }
@@ -1151,10 +1231,10 @@
     else
     {
       dbConn=conn;
-    }
+    }*/
 
     //create a DBTransform ojbect
-    xmlToHtml = new DBTransform(dbConn);
+    xmlToHtml = new DBTransform();
     //head of html
     htmlDoc.append("<html><head></head><body>");
     for (int i=0; i<docImplList.size(); i++)
@@ -1197,7 +1277,7 @@
     zipOut.putNextEntry(zEntry);
     zipOut.write(byteString, 0, byteString.length);
     zipOut.closeEntry();
-    dbConn.close();
+    //dbConn.close();
         
   }//addHtmlSummaryToZipOutputStream
   
@@ -1218,7 +1298,7 @@
     ZipOutputStream zOut = null;
     String elementDocid=null;
     DocumentImpl docImpls=null;
-    Connection dbConn = null;
+    //Connection dbConn = null;
     Vector docIdList=new Vector();
     Vector documentImplList=new Vector();
     Vector htmlDocumentImplList=new Vector();
@@ -1231,7 +1311,7 @@
     version=MetaCatUtil.getVersionFromString(docIdString);
  
     //get the connection to the database
-    if (conn == null || conn.isClosed())
+    /*if (conn == null || conn.isClosed())
     {
       dbConn = util.openDBConnection();
     }
@@ -1238,7 +1318,7 @@
     else
     {
       dbConn=conn;
-    }
+    }*/
 
     //check if the reqused docId is a data package id
     if (!isDataPackageId(docId))//if it is not, throw a exception
@@ -1245,14 +1325,14 @@
     {
       Exception e = new Exception("The request the doc id " +docIdString+
                                     " is not a data package id");
-      dbConn.close();
+      //dbConn.close();
       throw e;
     }
-    else if(!hasPermissionToExportPackage(dbConn, docId, user, groups))
+    else if(!hasPermissionToExportPackage(docId, user, groups))
     {
       Exception e = new Exception("User " + user + " does not have permission"
                        +" to export the data package " + docIdString);
-      dbConn.close();
+      //dbConn.close();
       throw e;
     }
     else //it is a packadge id
@@ -1295,7 +1375,7 @@
         docImpls=(DocumentImpl)documentImplList.elementAt(i);
         
         //checking if the user has the permission to read the documents
-        if (docImpls.hasReadPermission(dbConn,user,groups,docImpls.getDocID()))
+        if (docImpls.hasReadPermission(user,groups,docImpls.getDocID()))
         { 
             //if the docImpls is metadata 
           if ((docImpls.getDoctype()).compareTo("BIN")!=0)  
@@ -1321,7 +1401,7 @@
       //add html summary file
       addHtmlSummaryToZipOutputStream(htmlDocumentImplList, zOut, rootName);
       zOut.finish(); //terminate the zip file
-      dbConn.close();
+      //dbConn.close();
       return zOut;
     }//else
   }//getZippedPackage()
Index: src/edu/ucsb/nceas/metacat/MetaCatUtil.java
===================================================================
--- src/edu/ucsb/nceas/metacat/MetaCatUtil.java	(revision 1216)
+++ src/edu/ucsb/nceas/metacat/MetaCatUtil.java	(revision 1217)
@@ -50,7 +50,7 @@
   private static String propertiesFile = "edu.ucsb.nceas.metacat.metacat";
   private static boolean debug = false;
 
-  private Hashtable connectionPool = new Hashtable();
+  //private Hashtable connectionPool = new Hashtable();
 
   /** 
    * Determine our db adapter class and create an instance of that class
@@ -63,25 +63,8 @@
     }
   }
 
-// CONSTRUCTORS NOT NEEDED
-//  /**
-//   * Construct an instance of the utility class
-//   */
-//  public MetaCatUtil() {
-//
-//    options = (PropertyResourceBundle)
-//          PropertyResourceBundle.getBundle(propertiesFile);
-//  }
-//  
-//  /**
-//   * This constructor allows the usage of a different properties file
-//   * @param propFile the properties file that you wish to use.
-//   */
-//  public MetaCatUtil(String propFile)  {
-//
-//    propertiesFile = propFile;
-//  }
 
+
   /**
    * Instantiate a class using the name of the class at runtime
    *
@@ -132,152 +115,9 @@
     return value;
   }
 
-  /** 
-   * Utility method to establish a JDBC database connection using connection
-   * info from the properties file
-   */
-  public Connection openDBConnection()
-                throws SQLException, ClassNotFoundException {
-    return openDBConnection(getOption("dbDriver"), getOption("defaultDB"),
-                     getOption("user"), getOption("password"));
-  }
-
-  /** 
-   * Utility method to establish a JDBC database connection 
-   *
-   * @param dbDriver the string representing the database driver
-   * @param connection the string representing the database connectin parameters
-   * @param user name of the user to use for database connection
-   * @param password password for the user to use for database connection
-   */
-  public static Connection openDBConnection(String dbDriver, String connection,
-                String user, String password)
-                throws SQLException, ClassNotFoundException {
-
-     // Load the Oracle JDBC driver
-     Class.forName (dbDriver);
-
-     debugMessage("Opening connection: " + connection);
-     // Connect to the database
-     Connection conn = DriverManager.getConnection( connection, user, password);
-     return conn;
-  }
-
-  /* Utility method to create and return a pool of Connection objects */
-  public Hashtable getConnectionPool()
-                throws SQLException, ClassNotFoundException {
-
-    int initConn = (new Integer(getOption("initialConnections"))).intValue();
-    
-    for ( int i = 0; i < initConn; i++ ) {
-        connectionPool.put( openDBConnection(), Boolean.FALSE );
-    }    
-    
-    return connectionPool;
-  }
+ 
   
-  /* Utility method to get a unused Connection object from the pool */
-  public Connection getConnection()
-                throws SQLException, ClassNotFoundException, Exception 
-  {
-
-    Connection conn = null;
-    Enumeration connections = connectionPool.keys();
-    
-    synchronized (connectionPool) {
-      while (connections.hasMoreElements()) {
-
-        conn = (Connection)connections.nextElement();
-        Boolean b = (Boolean)connectionPool.get(conn);
-
-        if (conn == null || conn.isClosed()) {
-            // closed connection; replace it
-            conn = openDBConnection();
-            // update the pool to show this one taken
-            connectionPool.put(conn, Boolean.TRUE);  
-            
-            return conn;
-        } else if (b == Boolean.FALSE) {
-            // unused connection; test if it works and get it
-            try {
-                conn.setAutoCommit(true);
-            } catch (SQLException e) {
-                // problem with the connection, replace it
-                conn = openDBConnection();
-            }    
-            // update the pool to show this one taken
-            connectionPool.put(conn, Boolean.TRUE);    
-
-            return conn;
-        }    
-      }  
-    }   
-    
-    // If we get here, there no free connections;
-    // we need to make more
-    int incConn = (new Integer(getOption("incrementConnections"))).intValue();
-    int maxConn = (new Integer(getOption("maximumConnections"))).intValue();
-    int k = connectionPool.size();
-    if ( k >= maxConn ) {
-        throw new Exception("The maximum of " + maxConn + 
-                            " open db connections is reached." +
-                            " New db connection to MetaCat" +
-                            " cannot be established.");
-    }    
-
-    // decide how many new connections to open; no more than the maximum
-    if ( incConn > maxConn - k ) { incConn = maxConn - k; }
-    
-    // get them
-    for ( int i = 0; i < incConn; i++ ) {
-        connectionPool.put( openDBConnection(), Boolean.FALSE );
-    }
-
-    // Recurse to get one of the new connections
-    return getConnection();
-  }
   
-  /* Utility method to give the connection back to the pool */
-  public void returnConnection (Connection returned) {
-    
-    Connection conn;
-    Enumeration connections = connectionPool.keys();
-    
-    try {
-      if ( (returned != null) && !(returned.isClosed()) ) {
-        while (connections.hasMoreElements()) {
-          conn = (Connection)connections.nextElement();
-          if ( conn == returned ) {
-            connectionPool.put( conn, Boolean.FALSE );
-            break;
-          }    
-        }    
-      }
-    } catch (SQLException e) {}    
-  }
-
-  /* Return the size of the pool */
-  public int getPoolSize() {
-    return connectionPool.size();
-  }
-  
-  /* Utility method to close all the connection from the pool */
-  public void closeConnections() {
-    
-    Connection conn;
-    Enumeration connections = connectionPool.keys();
-    
-    while (connections.hasMoreElements()) {
-        conn = (Connection)connections.nextElement();
-        try {
-            if ( (conn != null) && !(conn.isClosed()) ) {
-              conn.close();
-            }    
-        } catch (SQLException e) {}    
-    }
-  }
-  
-  
   /** Utility method to convert a file handle into a URL */
   public static URL fileToURL(File file)
   {
Index: src/edu/ucsb/nceas/metacat/AssociateAccessPolicy.java
===================================================================
--- src/edu/ucsb/nceas/metacat/AssociateAccessPolicy.java	(revision 1216)
+++ src/edu/ucsb/nceas/metacat/AssociateAccessPolicy.java	(revision 1217)
@@ -62,7 +62,7 @@
 
  
  
-  private Connection  conn = null;
+  private DBConnection  conn = null;
   private Vector docIdInAccessTable=null;
   private Vector docIdWithoutAccessEntry=null;
   private Vector notFoundDataSetId=null;
@@ -75,15 +75,17 @@
    */
   static public void main(String[] args) 
   {
-     Connection localConn=null;
-     MetaCatUtil localUtil=new MetaCatUtil();
+     DBConnection localConn=null;
+     int serialNumber = -1;
+     //MetaCatUtil localUtil=new MetaCatUtil();
      AssociateAccessPolicy policy=null;
      try
      {
-      localConn=localUtil.openDBConnection();
+      localConn=DBConnectionPool.getDBConnection("AssociateAccessPolict.main");
+      serialNumber=localConn.getCheckOutSerialNumber();
       policy = new AssociateAccessPolicy(localConn);
       policy.associateAccess();
-      localConn.close();   
+      //localConn.close();   
      }//try
      catch (Exception e) 
      {
@@ -90,7 +92,12 @@
         System.err.println("Error in AssociateAccessPolicy.main");
         System.err.println(e.getMessage());
         e.printStackTrace(System.err);
-     } 
+     }
+     finally
+     {
+       DBConnectionPool.returnDBConnection(localConn, serialNumber);
+     }//finally
+     
      if (!(policy.getNotFoundDataSetId()).isEmpty())
      {
          
@@ -126,7 +133,7 @@
    * @param parserName the fully qualified name of a Java class implementing
    *                   the org.xml.sax.XMLReader interface
    */
-  public AssociateAccessPolicy( Connection conn) 
+  public AssociateAccessPolicy( DBConnection conn) 
                   throws IOException, 
                          SQLException, Exception
   {   
@@ -166,15 +173,7 @@
     PreparedStatement pStmt;
     String docId;
     ResultSet rs=null;
-    Connection dbConn=null;
-    if (conn == null || conn.isClosed())
-    {
-      dbConn = util.openDBConnection();
-    }
-    else
-    {
-      dbConn=conn;
-    }
+    
     //the query stirng
     String query="SELECT docid from xml_access";
     try
@@ -221,16 +220,9 @@
                       throws SQLException, McdbException,Exception
   {
     PreparedStatement pStmt;
-    Connection dbConn=null;
+    
     String query=null;
-    if (conn == null || conn.isClosed())
-    {
-      dbConn = util.openDBConnection();
-    }
-    else
-    {
-      dbConn=conn;
-    }
+  
     //the query stirng
     //we let accessfileid blank becuause we couldn't know access file
     query="INSERT INTO xml_access " + 
@@ -262,15 +254,8 @@
     PreparedStatement pStmt=null;
     String docId;
     ResultSet rs=null;
-    Connection dbConn=null;
-    if (conn == null || conn.isClosed())
-    {
-      dbConn = util.openDBConnection();
-    }
-    else
-    {
-      dbConn=conn;
-    }
+
+   
     //the query stirng
     String query="SELECT docid from xml_documents";
     try
